<% if @companies_petition.present? %>
    <div class="col-sm-12">
        <h1 class="title">Companies<br/>
            <!-- <small class="blue-text">Click on a company for more details</small> -->
        </h1>
    </div>
    <div class="clearfix"></div>

    <div class="tabbar">
        <ul class="nav nav-tabs" role="tablist">
            <li role="presentation" class="active"><a href="#tab1" aria-controls="tab1" role="tab" data-toggle="tab">Petitions</a></li>
            <% unless params[:type].eql?('alumni') %>
            <li role="presentation"><a href="#tab2" aria-controls="tab2" role="tab" data-toggle="tab">Average Salary</a></li>
            <% end %>
            <li role="presentation"><a href="#tab3" aria-controls="tab3" role="tab" data-toggle="tab" id="visa_map">Maps</a></li>
        </ul>
        <!-- Tab panes -->
        <div class="tab-content">
            <div role="tabpanel" class="tab-pane active" id="tab1">
                <div class="charts">
                    <% max_petition = companies_petition.first.no_of_petition.to_i + 10 %>
                    <%# chart_colors = [ 'cyan', 'red', 'blue', 'green', 'amber', 'purple', 'grey', 'yellow' ] %>
                    <% chart_colors = [ 'cyan', 'lavender', 'aqua', 'mustard', 'pink', 'lemon', 'carrot', 'sea', 'purple', 'green' ] %>
                    <% count = 0 %>
                    <% companies_petition.each_with_index do |company, index| %>
                        <% is_fav = FavoriteCompany.find_by(company_id: company.company_id, user_id: current_user.id).present? %>
                        <div class="chart-cell">
                            <a href="<%= company_path(id: company.company_id, tab_type: params[:type]) %>">
                                <span>
                                    <%= "#{company.employer_name.capitalize}" %> <b><%= "(#{number_with_delimiter(company.no_of_petition)})" %> </b>
                                    <div class="star_icon pull-right">
                                        <a data-toggle="tooltip" data-placement="right" title="Add to Favorite" href="javascript:void(0);" class="fav-icon  <%= is_fav ? 'active' : '' %>" data-company-id="<%= company.company_id %>" data-company-name="<%= company.employer_name %>" id="fav_company"></a>
                                    </div>
                                </span>
                                <!-- <div class="charts__chart chart--p90 chart--cyan" data-percent="<%#= company.no_of_petition  %>"></div> -->
                                <%# logger.info "====pet===#{company.no_of_petition}" %>
                                <% percent = (company.no_of_petition.to_f / max_petition.to_f) * 100 %>
                                <div class="charts__chart chart--p<%= percent.to_i %> chart--<%= chart_colors[count] %>" data-percent="<%= company.no_of_petition  %>"></div>
                            </a>
                        </div>
                        <% if count >= chart_colors.count - 1 %>
                            <% count = 0 %>
                        <%  else %>
                            <% count += 1 %>
                        <% end %>
                    <% end if companies_petition.present? %>
                </div>
            </div>
            <% if params[:type].present? && !params[:type].eql?('alumni') %>
            <div role="tabpanel" class="tab-pane" id="tab2">

                <div class="charts">
                    <% max_wage = companies_wage.first.wage_rate_of_pay_from.to_i + 10 %>
                    <%# chart_colors = [ 'cyan', 'red', 'blue', 'green', 'amber', 'purple', 'grey', 'yellow' ] %>
                    <% chart_colors = [ 'cyan', 'lavender', 'aqua', 'mustard', 'pink', 'lemon', 'carrot', 'sea', 'purple', 'green' ] %>
                    <% count = 0 %>
                    <% companies_wage.each_with_index do |company, index| %>
                        <% is_fav = FavoriteCompany.find_by(company_id: company.company_id, user_id: current_user.id).present? %>
                        <div class="chart-cell">
                            <a href="<%= company_path(id: company.company_id, tab_type: params[:type]) %>">
                                <span><%= "#{company.employer_name.capitalize}" %> <b><%= "($#{number_to_human(company.wage_rate_of_pay_from, format: '%n%u', precision: 2, units: { million: 'M', thousand: 'K' })})" %> </b></span>
                                <!-- <div class="charts__chart chart--p90 chart--cyan" data-percent="<%#= company.no_of_petition  %>"></div> -->
                                <%# logger.info "====pet===#{company.no_of_petition}" %>
                                <div class="star_icon pull-right">
                                    <a data-toggle="tooltip" data-placement="right" title="Add to Favorite" href="javascript:void(0);" class="fav-icon  <%= is_fav ? 'active' : '' %>" data-company-id="<%= company.company_id %>" data-company-name="<%= company.employer_name %>" id="fav_company"></a>
                                </div>
                                <% percent = (company.wage_rate_of_pay_from.to_f / max_wage.to_f) * 100 %>
                                <div class="charts__chart chart--p<%= percent.to_i %> chart--<%= chart_colors[count] %>" data-percent="<%= company.wage_rate_of_pay_from  %>"></div>
                            </a>
                        </div>
                        <% if count >= chart_colors.count - 1 %>
                            <% count = 0 %>
                        <%  else %>
                            <% count += 1 %>
                        <% end %>
                    <% end %>
                </div>
            </div>
            <% end %>
            <div role="tabpanel" class="tab-pane" id="tab3">
                <!-- <div style="position: absolute; width: 100%; height: 100%"> -->
                    <div id="map1"></div>
                <!-- </div> -->
            </div>
        </div>
    </div>
<% else %>
    <div class="col-sm-12 no_companies">
        <h1 class="title"> No companies found for this search </h1>
    </div>
<% end %>
<script src="https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/markerclusterer.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAQoyHt6t48brE7eZT4yGhSC4eGs0Hlclg"></script>
<!-- <script src="https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/markerclusterer.js"></script> -->
<script>
function initMap() {
          // var loct = <%#= raw(marker.to_json) %>
          // console.log(loct[0])
          // var map = new google.maps.Map(document.getElementById('map1'), {
          //   zoom: 5,
          //   // center: loct[0]
          // });
          // geocoder = new google.maps.Geocoder();
          // geocoder.geocode( { 'address': "Australia" }, function(results, status) {
          //     map.setCenter(results[0].geometry.location);
          //     var marker = new google.maps.Marker({
          //         map: map,
          //         position: results[0].geometry.location,
          //         // label: labels[i % labels.length]
          //     // alert(1)
          //     });
          // })

          var loct = <%= raw(marker.to_json) %>
          var map = new google.maps.Map(document.getElementById('map1'), {
              zoom: 3,
              center: loct[0]
          });


          var markers = loct.map(function(location, i) {
              //console.log(location);
              //console.log(i);
              return new google.maps.Marker({
                  position: location,
                  count: location.petition,
                  // label: labels[i % labels.length]
              });
              // alert(1)
          });

          var clusterStyles = [
              {
                textColor: 'white',
                url: '/assets/marker/small.png',
                height: 24,
                width: 24
              },
              {
                textColor: 'white',
                url: '/assets/marker/medium.png',
                height: 24,
                width: 24
              },
              {
                textColor: 'white',
                url: '/assets/marker/large.png',
                height: 32,
                width: 32
              },
             // {
             //    textColor: 'white',
             //    url: '/assets/marker/medium1.png',
             //    height: 50,
             //    width: 50
             //  },
             // {
             //    textColor: 'white',
             //    url: '/assets/marker/medium.png',
             //    height: 50,
             //    width: 50
             //  }
            ];

            var mcOptions = {
                gridSize: 50,
                styles: clusterStyles,
                // maxZoom: 15
            };

          // var markerCluster = new MarkerClusterer(map, markers, {imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m'});
          var markerCluster = new MarkerClusterer(map, markers, mcOptions);

          markerCluster.setCalculator(function(markers, numStyles){
              //create an index for icon styles
                  // console.log(markers);
                  var sum = 0
                  $.each(markers, function(i, value){
                      // console.log("=============");
                      // console.log(value);
                      sum = sum + value.count
                  })
                  // markers.each(function(value, i){
                  //     console.log("===================================");
                  //     console.log(value);
                  //     console.log(i);
                  //     console.log("===================================");
                  // })
                  // count = sum + markers.length,
                  count = sum,
              //Set total to loop through (starts at total number)
                  total = count;
                  var index = 0
                  while (total !== 0) {
                      //Create a new total by dividing by a set number
                      total = parseInt(total / 5, 10);
                      //Increase the index and move up to the next style
                      index++;
                  }

                  /**
                   * Make sure we always return a valid index. E.g. If we only have
                   * 5 styles, but the index is 8, this will make sure we return
                   * 5. Returning an index of 8 wouldn't have a marker style.
                   */
                  index = Math.min(index, numStyles);


              return {
                  // text: count + " ("+ index + ")",
                  // index: index
                  text: prettifyNumber(count),
                  index: index
              };
          });

          // geocoder.geocode( { 'address': "<%#= @country.name %>" }, function(results, status) {
          //     map.setCenter(results[0].geometry.location);
          // }

          // // Add a marker clusterer to manage the markers.
          // var markerCluster = new MarkerClusterer(map, markers, {imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m'});
}

function prettifyNumber(value) {
    var thousand = 1000;
    var million = 1000000;
    var billion = 1000000000;
    var trillion = 1000000000000;
    if (value < thousand) {
        return String(value);
    }

    if (value >= thousand && value <= 1000000) {
         return  Math.round(value/thousand) + 'k';
    }

    if (value >= million && value <= billion) {
        return Math.round(value/million) + 'M';
        }

         if (value >= billion && value <= trillion) {
             return Math.round(value/billion) + 'B';
         }

         else {
             return Math.round(value/trillion) + 'T';
         }
     }

$('#visa_map').on('click', function(){
    $('.loader').show();
    initMap();
    // height: 100%; width: 100%; position: absolute; top: 0px; left: 0px; background-color: rgb(229, 227, 223);
    setTimeout(function(){
        $('#map1 div').first().removeAttr('style')
        $('#map1 div').first().css({ 'height': '500px', 'width' : '500px', 'top': '0px', 'left': '0px', 'background-color': 'rgb(229, 227, 223)', 'position': 'relative !important' });
    }, 1000)
    $('.loader').hide()
})
</script>
